;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = game speed to set
;DWORD [object+12] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)
;DWORD [object+16] = initial run once value (for re-init)

struct CAT101
       lpVTable 		dd	?
       refCount 		dd	?
       SetSpeed 		dd	?
       Flags			dd	?
       InitialFlags		dd	?
ends

align 16
;==========================================================
AT101MAIN:
;==========================================================
cmp BYTE [ecx+12],3
    jz RunAlreadyOnce101
	or DWORD [ecx+12],2	;set run once bit

	mov eax,[ecx+8]
	mov edx,[GameSpeedVarADDR]
	mov [NormalGameSpeed],eax
	cmp [BIONICWOMAN_enabled],1
	    jz AT101MAIN_NOGSPDMODIFYDIRECT
	mov [edx],eax
	AT101MAIN_NOGSPDMODIFYDIRECT:

RunAlreadyOnce101:
ret

align 16
;==========================================================
AT101_REINIT:
;==========================================================
mov eax,[ecx+16]
mov [ecx+12],eax
mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT101Init:
;====================================================================
ALLOCAT 20

lea eax,[AT101]
mov [edi],eax
mov DWORD [edi+4],0
	mov eax,[DefaultSlowSpeed]
mov DWORD [edi+8],eax
mov DWORD [edi+12],0

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Frame,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT