;============================================================
;CLASS OUTPUTTER STRUCTS AND CONSTANTS
;============================================================
;EDIT: INCOMPLETE

struct outfile_header
       Name		dd	'COTP'
       ClassCount	dd	?
       FileEndOffset	dd	?	    ;points to EOF (thus, is file size)
					    ;after this is the list of vtable_desc instances
ends

struct vtable_desc
       VTable			dd	?	;if class has no VTable, this is a number below 1000
       ClassNameOffset		dd	?	;(from outfile_header.Name start)
       ClassLength		dd	?	;in bytes (with VTable) - will be at least 4 if discovered, 0 otherwise
       ClassDataOffset		dd	?	;(from outfile_header.Name start)
       InheritCount		dd	?	;number of inherited classes (including self)
       InheritOffset		dd	?	;points to list of DWORDS designating vtable_desc structs (from outfile_header.Name start)
       InheritStringsOffset	dd	?
ends

;ClassDataOffset entry definitions
;all entries in class data are DWORDs. Because of the limited size of
;tresclasses.cdd, it is safe to assume that less than 24 bits will be
;used to reference vtable_desc structures from within the file using
;offsets when the DWORDs refer to pointers to class instances. Thus,
;the highest 8 bits can be used to determine the data type of the DWORD entry,
;i.e., pointer to class instance, pointer to string, etc.

COUTP_CLASSENTRY_POINTER_INSTANCE	 equ	 80000000h	;pointer to other class instance not found within instance (low 24-bit give class offset within tresclasses.cdd file or value of 1 if CObject)
COUTP_CLASSENTRY_POINTER_MEMORY 	 equ	 40000000h	;pointer to misc. memory not found within instance
COUTP_CLASSENTRY_POINTER_STRING 	 equ	 20000000h	;pointer to null-terminated string, may or may not be within instance (4 characters or more)
COUTP_CLASSENTRY_POINTER_SUBMEMBER	 equ	 10000000h	;pointer to part of same instance (low 24-bit will give offset within class)
COUTP_CLASSENTRY_POINTER_SUBINSTANCE	 equ	 08000000h	;pointer to other class instance found within same instance (low 24-bit will give offset within class)
								;SUB-INSTANCE'S NAME IS STORED AS OFFSET IN TRESCLASSES.CDD IN CASE VTABLE IS NOT FOUND IN DEFAULT FILE
COUTP_CLASSENTRY_MEMBER_STRING		 equ	 04000000h	;start of string (low 24-bit = max recorded string size)
COUTP_CLASSENTRY_MEMBER_STRINGEXT	 equ	 02000000h	;extension of string (dummy)
COUTP_CLASSENTRY_MEMBER_VTABLE		 equ	 01000000h	;VTable within same instance
;if entry has none of these flags, it has not yet been 'discovered' by the scanner

COUTP_CLASSENTRY_CHECKALL		 equ	0FF000000h

CLASS_OUTPUTTER_OUTFILE_EXT_SIZE     equ     8000000 ;size added to cdd file contents (for internal buffer only)
CLASS_OUTPUTTER_COBJECT_ID	     equ     1

