;============================================================
;FOLLOWDINO CHEAT REAL-TIME CODE (ALSO WORKS IN CONJUNCTION WITH OBJF CHEAT)
;============================================================

;============================================================
DoFollowDinoRTMain:
;============================================================
cmp [IsInGame_BOOL],0
     jz NoDoFollowDinoRTMain

;------------------------------------
;key handler
;------------------------------------

cmp [IsInConsole_BOOL],1
     jz NoFollowDinoRTMain_InputHandler

invoke GetTickCount
    sub eax,[FD_tickcountinput]
    cmp eax,[FD_inputinterval]
    mov [esp-4],eax
	jb NoFollowDinoRTMain_InputHandler

    add [FD_tickcountinput],eax
    fild DWORD [esp-4]
    mov edi,[KEY_LIST_ADDR]
    fstp [FD_floattimeinput]

    invoke GetAsyncKeyState,[edi+80]
    test eax,80000000h
	 jz NoDoFollowDinoRTResetDistance
	 mov eax,[FD_distanceoriginal]
	 mov [FD_distance],eax
	 jmp NoDoFollowDinoRTKeyBackSlow
    NoDoFollowDinoRTResetDistance:

    invoke GetAsyncKeyState,[edi+88]
    test eax,80000000h
	 jz NoDoFollowDinoRTKeyFrontSlow
	 fld [FD_distancespeed]
	 fchs
	 fmul [FD_floattimeinput]
	 fadd [FD_distance]
	 fst [FD_distance]
	 fcomp [float_0]
	 fstsw ax
	 test ah,1h
	      jz NoDoFollowDinoRTKeyBackSlow
	      mov [FD_distance],0
	 jmp NoDoFollowDinoRTKeyBackSlow
    NoDoFollowDinoRTKeyFrontSlow:

    invoke GetAsyncKeyState,[edi+96]
    test eax,80000000h
	 jz NoDoFollowDinoRTKeyBackSlow
	 fld [FD_distancespeed]
	 fmul [FD_floattimeinput]
	 fadd [FD_distance]
	 fstp [FD_distance]
    NoDoFollowDinoRTKeyBackSlow:

NoFollowDinoRTMain_InputHandler:

;------------------------------------
;camera mvt updater
;------------------------------------

    call [FD_fetchfunction]
    test ebx,ebx
	 jz NoFollowDinoRTMain_CamMvtUpdater

sub esp,4*(3+4)

    mov eax,[ebx+30h]		    ;copy instance position values
    mov ecx,[ebx+34h]
    mov edx,[ebx+38h]
    mov [esp],eax
    mov [esp+4],ecx
    mov [esp+8],edx

    mov eax,FD_distance
    mov edx,esp
    mov ecx,FD_xangle
    call FacingRad2CompToVector_Sub	;calculate new camera position values (follow object)

    lea edx,[esp+(4*3)]
    mov ecx,FD_xangle
    stdcall FDConvAnglesToQuat,edx	;calculate new camera orientation


    mov edx,esp
    call CCameraTeleport

add esp,4*(3+4)

NoFollowDinoRTMain_CamMvtUpdater:
;------------------------------------

NoDoFollowDinoRTMain:

ret

;============================================================
;FOLLOWDINO INSTANCE FETCH PROCEDURES
;============================================================
;All return instance to follow in _ebx_ or NULL if none
;They must be set in [FD_fetchfunction] (only one permitted at once)

;============================================================
FD_FetchCAnimalInstance:
;============================================================
	mov eax,[CAnimalBuffer]
	xor ebx,ebx
	test eax,eax
	mov ecx,[DisplayDino_INDEX]
	    jz NoFD_FetchCAnimalInstance
	mov ebx,[eax+ecx+canimal_info.Instance]
NoFD_FetchCAnimalInstance:
ret

;============================================================
FD_FetchOBJNInstance:
;============================================================
	mov ebx,[OBJN_instance]
ret

;============================================================
;MOVEMENT HANDLER(S)
;============================================================

;============================================================
DoFollowDinoRTMouseMvtHandler:	    ;cannot change ebx,ebp,esi,edi
;============================================================
;[esi+28h] = last X POINT value
;[esi+2Ch] = last Y POINT value

sub esp,8

    push esp
    invoke GetCursorPos
    mov eax,[esp]
    mov ecx,[esp+4]
    sub eax,[esi+28h]
    sub ecx,[esi+2Ch]
    mov [esp],eax
    mov [esp+4],ecx

;sub from xangle
    fild DWORD [esp]
    fmul [FD_mousectrlmultiplier]
    fsubr [FD_xangle]

;insure xangle is within range 0 to 2pi (not optimized)
    FD_xanglenotbelow2pi_loop:
    fcom [pi2]
    fstsw ax
    test ah,1h
	 jnz FD_xanglebelow2pi
	 fsub [pi2]
    jmp FD_xanglenotbelow2pi_loop
    FD_xanglebelow2pi:

    FD_xanglenotbelow0_loop:
    fcom [float_0]
    fstsw ax
    test ah,1h
	 jz FD_xanglebelow0
	 fadd [pi2]
    jmp FD_xanglenotbelow0_loop
    FD_xanglebelow0:

    fstp [FD_xangle]

;add to zangle
    fild DWORD [esp+4]
    fmul [FD_mousectrlmultiplier]
    fmul [FD_invertmousemul]
    fadd [FD_zangle]
    fst [FD_zangle]

;test for zangle limits
    fcom [FD_zanglemin]
    mov ecx,[FD_zanglemin]
    fstsw ax
    test ah,1h
	 jz FD_zanglenotminreached
	 mov [FD_zangle],ecx
    FD_zanglenotminreached:

    fcomp [FD_zanglemax]
    mov ecx,[FD_zanglemax]
    fstsw ax
    test ah,41h
	 jnz FD_zanglenotmaxreached
	 mov [FD_zangle],ecx
    FD_zanglenotmaxreached:

add esp,8
ret

