;=====================================================
;VARIOUS PROCEDURES (SSE VERSIONS)
;=====================================================
;NONE OF THESE ARE PROPERLY IMPLEMENTED!!!!!!!!!
;DO NOT USE!!!!!!!!! TRESPASSER SEEMS TO RUN INTO PROBLEMS
;WITH THESE AT TIMES!!!!!!!!!

;LACKS PRECISION!!!!!!!!!!


align 16
;=====================================================
ObjVectorDisplace_SSE:	  ;ecx = location struct
;=====================================================
;param1 = dest position (return in eax), param2 = source vector
	push esi

;note: can use DWORD [esp-4] ONLY as local var (due to push ecx)

   ;copy source vector to aligned mem on stack (will also be used for dest. copy)
	push ecx
	lea edx,[esp-16]
	mov esi,[esp+8+8]	;source vect.
	and edx,not 15		;edx may 'grow downward' to accomodate alignment
	mov eax,[esi]
	mov ecx,[esi+4]
	mov [edx],eax
	mov [edx+4],ecx
	mov eax,[esi+8]
	xor ecx,ecx
	mov [edx+8],eax
	mov [edx+0Ch],ecx

	pop ecx

	cmp DWORD [ecx+0Ch],1.000000
	    jnz .notdefaultquat

	movss xmm2,[ecx+1Ch]	  ;scale
	movaps xmm0,[edx]	  ;get vector values
	SHUFXMM xmm2,0,0,0,0	  ;extend scale into all DWORDs

	movups xmm1,[ecx]	  ;fetch location values (4th float is quat.w, ignored)
	mulps xmm0,xmm2 	  ;scale*vector
	addps xmm0,xmm1 	  ;add location values

jmp .storevalue

.notdefaultquat:
    ;compute ^2 for all quat components
	mov eax,[ObjVectorDispVar]
	fld QWORD [eax]
	fstp DWORD [esp-4]

	movups xmm0,[ecx+0Ch]		;q.w,q.x,q.y,q.z

	movups xmm4,xmm0		;save quat values
	movups xmm5,xmm0		;save quat values
	movups xmm6,xmm0		;save quat values
	movups xmm7,xmm0		;save quat values

	mulps xmm0,xmm0 		;q.w^2,q.x^2,q.y^2,q.z^2

    ;arrange source vector values into xmm2
	movss xmm1,xmm0 		;copy q.w^2
	subss xmm1,DWORD [esp-4]	;q.w^2-extvar in lowest DWORD of xmm1
	movaps xmm2,[edx]		;v.x,v.y,v.z in xmm2

    ;arrange quat values for cross products:
    ;xmm4: qy*qx, qz*qy, qz*qx
    ;xmm6: qz*qw, qx*qw, qy*qw
	   SHUFXMM xmm4,2,3,3,0 	   ;qy,qz,qz
	   SHUFXMM xmm5,1,2,1,0 	   ;qx,qy,qx

    ;arrange q.w^2 into xmm1 with sub... *
	SHUFXMM xmm1,0,0,0,0		   ;extend into all xmm1 DWORD regs
	SHUFXMM xmm0,1,2,3,0		   ;shift register with qx^2, qy^2, qz^2 down

	   SHUFXMM xmm6,3,1,2,0 	   ;qz,qx,qy
	   SHUFXMM xmm7,0,0,0,0 	   ;qw,qw,qw

    ;* ...and add to ^2 quat components
	addps xmm0,xmm1 		;(qx)^2+((qw)^2-extvar), (qy)^2+((qw)^2-extvar), (qz)^2+((qw)^2-extvar)

    ;multiply first part of eq. with vector values
	movups xmm1,xmm2	;save vector values
	mulps xmm0,xmm2 	;((qx)^2+((qw)^2-extvar))*vx), etc.

    ;do cross products
	mulps xmm4,xmm5
	mulps xmm6,xmm7
	movups xmm3,xmm4

	movss xmm5,[ecx+1Ch]	;get scale

    ;then, must perform xmm3=xmm4+xmm6 and xmm4=xmm4-xmm6
	addps xmm3,xmm6 	;xmm3 = qy*qx+qz*qw, qz*qy+qx*qw, qz*qx+qy*qw
	subps xmm4,xmm6 	;xmm4 = qy*qx-qz*qw, qz*qy-qx*qw, qz*qx-qy*qw
	addss xmm5,xmm5 	;scale*2

    ;multiply other eqs. with vector values (+align)
    ;must have (for add later):
    ; xmm1 = (qz*qx+qy*qw)*vz, (qy*qx+qz*qw)*vx, (qz*qy+qx*qw)*vy
    ; xmm2 = (qy*qx-qz*qw)*vy, (qz*qy-qx*qw)*vz, (qz*qx-qy*qw)*vx  ;(xmm4 -> no shuffle)
	 ; SHUFXMM xmm3,2,0,1,0
	 ; SHUFXMM xmm1,2,0,1,0
	SHUFXMM xmm2,1,2,0,0
	SHUFXMM xmm5,0,0,0,0		;extend scale*2 into all DWORDs
	mulps xmm1,xmm3
	mulps xmm2,xmm4
	   SHUFXMM xmm1,2,0,1,0 	;'hardcoded'

	addps xmm1,xmm2 	;add two last eq. parts
	addps xmm0,xmm1 	;add all parts (i.e., two last parts+first part)
	movups xmm2,[ecx]	;get location values (last unused float is valid)
	mulps xmm0,xmm5 	;multiply by scale*2
	addps xmm0,xmm2

.storevalue:	   ;result in xmm0
	movups [edx],xmm0
	mov eax,[esp+8]
	mov ecx,[edx]
	mov esi,[edx+4]
	mov [eax],ecx
	mov [eax+4],esi
	mov ecx,[edx+8]
	mov [eax+8],ecx
	pop esi
ret 8

nop
nop
nop
nop
ObjVectorDisplace_SSE_END:

;dx= ( (qx^2+(qw^2-extvar))*vx + (qy*qx-qz*qw)*vy + (qz*qx+qy*qw)*vz )*scale*2 + lx
;dy= ( (qy^2+(qw^2-extvar))*vy + (qy*qx+qz*qw)*vx + (qz*qy-qx*qw)*vz )*scale*2 + ly
;dz= ( (qz^2+(qw^2-extvar))*vz + (qz*qx-qy*qw)*vx + (qz*qy+qx*qw)*vy )*scale*2 + lz


