;TURNS OFF FIXED OBJECT SPEED MODE
;no effect if instance is not currently in fixed-speed mode
;object:
;DWORD [obj] = VTable Pointer
;DWORD [obj+4] = n/a
;DWORD [obj+8] = instance name ID

struct CAT111
       lpVTable 		dd	?
       refCount 		dd	?
       InstanceNameID		dd	?
ends

align 16
;==========================================================
AT111MAIN:
;==========================================================
push esi

	mov esi,[FIXS_mainbuffer]
	mov edx,[FIXS_mainbuffer_sizediv2]
	test esi,esi
	mov eax,[ecx+AT110Data.InstanceNameID]
	     jz NoAT111MAIN

	AT111MAIN_MainLoop:
	cmp [esi],eax
	    jz NoAT111MAIN_InstanceID_FOUND
	add esi,4
	cmp esi,[FIXS_mainbuffer_halfend]
	    jb AT111MAIN_MainLoop

NoAT111MAIN:
pop esi
ret

NoAT111MAIN_InstanceID_FOUND:
	mov DWORD [esi],0
	invoke LocalFree,[esi+edx]

pop esi
ret

align 16
;==========================================================
AT111_REINIT:
;==========================================================
	mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT111Init:
;====================================================================
ALLOCAT 12
lea eax,[AT111]
mov [edi+0],eax
mov [edi+4],DWORD 0
GETVALUE Sample,0
SETVALUE2 value_string			   ;(in eax)

	invoke GETTEMPINST_PROC,eax,0,1    ;returns string ID (case-sensitive, unique)
	add esp,12
	mov [edi+8],eax

	jmp ExitINAT