;============================================================
;GENERAL MACROS
;============================================================

;these VTable_xxxxxx macros help define the custom new ActionType VTables
;in the exe data and addresses buffer
;===================================================================
macro VTable_P6_1_1 [atname] {
;===================================================================
      if used atname
      atname:
	dd 0044CDB0h
	dd 0040FDC0h
	dd atname#MAIN
	dd 00468A60h
	dd 0044AA60h
	dd atname#_REINIT
	dd 004F2F80h
	dd 0
	dd 0
	dd 0
      end if
      }

;===================================================================
macro VTable_K6_1_1 [atname] {
;===================================================================
      if used atname
	dd 0044C9C0h
	dd 0040FC50h
	dd atname#MAIN
	dd 004EAA20h
	dd 004BC160h
	dd atname#_REINIT
	dd 004EF9A0h
	dd 0
	dd 0
	dd 0
      end if
      }

;===================================================================
macro VTable_P5_1_1 [atname] {
;===================================================================
      if used atname
	dd 0044CFD0h
	dd 0040FD60h
	dd atname#MAIN
	dd 00403220h
	dd 0044AC60h
	dd atname#_REINIT
	dd 0044AC70h
	dd 0
	dd 0
	dd 0
      end if
      }

;===================================================================
macro VTable_P5_Demo [atname] {
;===================================================================
      if used atname
	dd 0044AAB0h
	dd 0040FB10h
	dd atname#MAIN
	dd 00403210h
	dd 00448B80h
	dd atname#_REINIT
	dd 004F2CC0h
	dd 0
	dd 0
	dd 0
      end if
      }

;===================================================================
macro EXEDATA p6labelname,k6labelname,p5labelname,demolabelname,basedataname,\
	      [p611addr,k611addr,p511addr,demoaddr,dataname] {
;===================================================================
;defines exe addresses (creates 4 large buffers, one for each executable type,
;instead of storing addresses alternatively)

      common
      basedataname:
      p6labelname:
      VTable_P6_1_1 AT100,AT101,AT102,AT103,AT104,AT105,AT106,AT107,AT108,\
		    AT109,AT110,AT111,AT112,AT113,AT114,AT115,AT116,AT117,\
		    AT118,AT119,AT120,AT121,AT122,AT123,AT124,AT125,AT126,\
		    AT127,AT128,AT129,AT130,AT131,AT132,AT133,AT134,AT135,\
		    AT136,AT137,AT138,AT139,AT140,AT141,AT142,AT143,AT144,\
		    AT145,AT146,AT147,AT148,AT149,AT150,AT151,AT152,AT153,\
		    AT154,AT155,AT156,AT157,AT158,AT159,AT160,AT161,AT162,\
		    AT163,AT164,AT165,AT166,AT167,AT168,AT169,AT170,AT171,\
		    AT172,AT173,AT174,AT175,AT176,AT177,AT178,AT179,AT180,\
		    AT181,AT182,AT183,AT184,AT185,AT186,AT187,AT188,AT189,\
		    AT190,AT191,AT192,AT193,AT194,AT195,AT196,AT197,AT198,AT199
	forward
	if used dataname
	   label dataname DWORD
	   dd p611addr
	end if

      common
      k6labelname:
      VTable_K6_1_1 AT100,AT101,AT102,AT103,AT104,AT105,AT106,AT107,AT108,\
		    AT109,AT110,AT111,AT112,AT113,AT114,AT115,AT116,AT117,\
		    AT118,AT119,AT120,AT121,AT122,AT123,AT124,AT125,AT126,\
		    AT127,AT128,AT129,AT130,AT131,AT132,AT133,AT134,AT135,\
		    AT136,AT137,AT138,AT139,AT140,AT141,AT142,AT143,AT144,\
		    AT145,AT146,AT147,AT148,AT149,AT150,AT151,AT152,AT153,\
		    AT154,AT155,AT156,AT157,AT158,AT159,AT160,AT161,AT162,\
		    AT163,AT164,AT165,AT166,AT167,AT168,AT169,AT170,AT171,\
		    AT172,AT173,AT174,AT175,AT176,AT177,AT178,AT179,AT180,\
		    AT181,AT182,AT183,AT184,AT185,AT186,AT187,AT188,AT189,\
		    AT190,AT191,AT192,AT193,AT194,AT195,AT196,AT197,AT198,AT199
	forward
	if used dataname
	   dd k611addr
	end if

      common
      p5labelname:
      VTable_P5_1_1 AT100,AT101,AT102,AT103,AT104,AT105,AT106,AT107,AT108,\
		    AT109,AT110,AT111,AT112,AT113,AT114,AT115,AT116,AT117,\
		    AT118,AT119,AT120,AT121,AT122,AT123,AT124,AT125,AT126,\
		    AT127,AT128,AT129,AT130,AT131,AT132,AT133,AT134,AT135,\
		    AT136,AT137,AT138,AT139,AT140,AT141,AT142,AT143,AT144,\
		    AT145,AT146,AT147,AT148,AT149,AT150,AT151,AT152,AT153,\
		    AT154,AT155,AT156,AT157,AT158,AT159,AT160,AT161,AT162,\
		    AT163,AT164,AT165,AT166,AT167,AT168,AT169,AT170,AT171,\
		    AT172,AT173,AT174,AT175,AT176,AT177,AT178,AT179,AT180,\
		    AT181,AT182,AT183,AT184,AT185,AT186,AT187,AT188,AT189,\
		    AT190,AT191,AT192,AT193,AT194,AT195,AT196,AT197,AT198,AT199
	forward
	if used dataname
	   dd p511addr
	end if

      common
      demolabelname:
      VTable_P5_Demo AT100,AT101,AT102,AT103,AT104,AT105,AT106,AT107,AT108,\
		     AT109,AT110,AT111,AT112,AT113,AT114,AT115,AT116,AT117,\
		     AT118,AT119,AT120,AT121,AT122,AT123,AT124,AT125,AT126,\
		     AT127,AT128,AT129,AT130,AT131,AT132,AT133,AT134,AT135,\
		     AT136,AT137,AT138,AT139,AT140,AT141,AT142,AT143,AT144,\
		     AT145,AT146,AT147,AT148,AT149,AT150,AT151,AT152,AT153,\
		     AT154,AT155,AT156,AT157,AT158,AT159,AT160,AT161,AT162,\
		     AT163,AT164,AT165,AT166,AT167,AT168,AT169,AT170,AT171,\
		     AT172,AT173,AT174,AT175,AT176,AT177,AT178,AT179,AT180,\
		     AT181,AT182,AT183,AT184,AT185,AT186,AT187,AT188,AT189,\
		     AT190,AT191,AT192,AT193,AT194,AT195,AT196,AT197,AT198,AT199
	forward
	if used dataname
	   dd demoaddr
	end if
      }

;===================================================================
MACRO DEFINENEWCHEATS cheattablename,cheattablemembersname,cheattablemembersendname,\
		      cheatjumpindexname,newcheatsindexname,newcheatsindexendname,\
		      cheathotkeyproctablenameRT,\
		      [cheatstring,cheatproc] {
;===================================================================
   common
      align 16

      cheattablename:
       times ((cheattablemembersendname-cheattablemembersname)+DEFAULT_CHEAT_ENTRY_COUNT*8) db 0

   forward	;defines string names

      STRING_#cheatstring	db	`cheatstring
				db	0

   common
      align 16
      cheattablemembersname:
   forward
	dd STRING_#cheatstring
	dd 0
   common
      cheattablemembersendname:

      align 16
      cheatjumpindexname:
	times ((newcheatsindexendname-newcheatsindexname)+DEFAULT_CHEAT_ENTRY_COUNT*4)	db	0

      newcheatsindexname:
   forward
	dd	cheatproc
   common
       newcheatsindexendname:

       cheathotkeyproctablenameRT:	;this table will be generated after loading, while scanning for hotkeys from INI (to optimize real-time work)
       times (DefaultTotalNumberOfCheats*sizeof.CheatHotKeyTableEntry)	 db	 0

      }

;===================================================================
MACRO DOHOTSPOTCLICK var1,section1,key1,object1 {
;===================================================================
;This macro will toggle the specified variable as well as its
;ATXconfig.ini counterpart, followed by a call to its assigned
;checkbox to set its state (checked, unchecked).

	     mov eax,[var1]
	     and eax,1
	     xor eax,1
	     mov [var1],eax
	     add al,30h
	     lea edx,[esp-4]
	     push eax
      invoke WritePrivateProfileString,section1,key1,edx,ATXconfiginiFN
	     mov ecx,[object1]
	     add esp,4
	     mov eax,[ecx]
	     push [var1]	     ;1 for checked, 0 for unchecked
	     call DWORD [eax+58h]    ;call set checkbox state method
      jmp EXIT_HOTSPOT_METHOD_INTERCEPT
      }

;===================================================================
MACRO ATXDRV_TESTKEY keyoffset,proc1,lasttickcount,interval {
;===================================================================
;edi = base of keyboard command table (in EXE), esi = current tick count

local nofunccall
      mov eax,esi
      sub eax,lasttickcount
      cmp eax,interval
      push eax
	  jb nofunccall
      mov lasttickcount,esi
      invoke GetAsyncKeyState,[edi+keyoffset]
      test eax,80000000h
	   jz nofunccall
	   call proc1				;PROC MUST NOT POP PARAMETERS
	   or [ATXDRV_CURRENT.UseROTonSMVTOnly],2
      nofunccall:
      add esp,4
      }

;===================================================================
MACRO SHOWTEMPMESSAGE themessage {
;===================================================================
      mov [TempMessageString],themessage
      invoke GetTickCount
      mov [TempMessageTime],eax
      }

;===================================================================
MACRO BBMCALL func1,varcheck1 {
;===================================================================
      cmp varcheck1,0
	  jz @f
      call func1
      @@:
      }

;===================================================================
MACRO RCALL releaseproc, param1 {
;===================================================================
      cmp param1,0
	  jz @f
      invoke releaseproc,param1
      mov param1,0
      @@:
      }

;===================================================================
MACRO COMPSTR string1,string2 {
;===================================================================
      lea ecx,string1
      lea edx,string2
      call CompareStrings
      }

;===================================================================
MACRO NOZERO reg1 {
;===================================================================
      test reg1,reg1
	   jnz @f
	   or reg1,1
      @@:
      }

;===================================================================
MACRO GETPLAYERLOCADDR	{     ;returns pointer to three loc values in eax
;===================================================================
      mov eax,[LocationADDR]
      mov eax,[eax]
      mov eax,[eax+14h]       ;main player location/other object
      add eax,30h	      ;eax now points to 32-bit floats x,y,z positions
      } 		      ;directly in the executable

;===================================================================
MACRO CLOSEHANDLE handlevalue {
;===================================================================
      cmp handlevalue,0
	  jz @f
      invoke CloseHandle,handlevalue
      @@:
      }

;===================================================================
MACRO FINDSTRINGSTART reg1 {	       ;scans for string start amidst space/tab characters
;===================================================================
local EndSearchString,SearchLoop
      dec reg1
      SearchLoop:
      inc reg1
      cmp BYTE [reg1],09h	       ;tab
	  jz SearchLoop
      cmp BYTE [reg1],20h	       ;space
	  jz SearchLoop
      EndSearchString:
      }

;===================================================================
MACRO FINDSTRINGEND reg1 {
;===================================================================
local NoNullTerminator,StringSizeNull
      cmp BYTE [reg1],0
	  jz StringSizeNull
      NoNullTerminator:
      inc reg1
      cmp BYTE [reg1],0
	  jnz NoNullTerminator
      StringSizeNull:
      }



;===================================================================
MACRO LOCALRELEASE buffer1 {
;===================================================================
;note: In many instances, the line "and buffer1,0" is unnecessary, but will never
;cause problems. As such, it is not fully optimized.

	cmp buffer1,0
	    jz @f
	    invoke LocalFree,buffer1
	    mov buffer1,0
	@@:
	}

;===================================================================
MACRO LOCALRELEASENONULL buffer1 {
;===================================================================
	cmp buffer1,0
	    jz @f
	    invoke LocalFree,buffer1
	@@:
	}

;===================================================================
MACRO VIRTUALRELEASE buffer1,size1  {
;===================================================================
	cmp buffer1,0
	    jz @f
	    invoke VirtualFree,buffer1,size1,MEM_DECOMMIT
	    invoke VirtualFree,buffer1,0,MEM_RELEASE
	    mov buffer1,0
	@@:
	}

;===================================================================
MACRO VIRTUALRELEASENONULL buffer1,size1  {
;===================================================================
	cmp buffer1,0
	    jz @f
	    invoke VirtualFree,buffer1,size1,MEM_DECOMMIT
	    invoke VirtualFree,buffer1,0,MEM_RELEASE
	@@:
	}

;=========================================================
;INITIALIZATION MACROS
;=========================================================

;===================================================================
MACRO WRITELOG _string,_failbool,_doexit {
;===================================================================
	or [DLLLoadSuccessBool],_failbool
	push _string
	push _failbool
	call WriteLogFile

   if _doexit eq WRITELOG_EXIT
	cmp _failbool,1
	    jz ExitInit
   end if
   if _doexit eq WRITELOG_FORCEEXIT
	    jmp ExitInit
   end if
	}

;===================================================================
;RT MACROS
;===================================================================
;some macros may only be valid for specific include files

;===================================================================
MACRO CHAR_TOLOWERCASE reg {
;===================================================================
	cmp reg,5Ah
	    ja @f
	cmp reg,41h
	    jb @f
	add reg,20h
	@@:
	}

;===================================================================
MACRO CHAR_TOUPPERCASE reg {
;===================================================================
	cmp reg,61h
	    jb @f
	cmp reg,7Ah
	    ja @f
	sub reg,20h
	@@:
	}

;===================================================================
macro SCANFOR string1 {
;===================================================================
      local ScanForLoop
	ScanForLoop:
	inc edi
	cmp edi,ebx
	jnb NEW_BITMAP_LOAD_FAIL
	cmp DWORD [edi],string1
	jnz ScanForLoop
	add edi,4
	cmp edi,ebx
	jnb NEW_BITMAP_LOAD_FAIL
	    }

;============================================================
MACRO ZEROMEM { 	 ;ecx = number of bytes, edi = buffer
;===================================================================
      local DoPerByteNullify,NoDoPerByteNullify
      mov edx,ecx
      test ecx,0FFFFFFFCh
	  jz DoPerByteNullify
      xor eax,eax
      shr ecx,2
      rep stosd
      DoPerByteNullify:
      and edx,3
	  jz NoDoPerByteNullify
	  mov ecx,edx
	  rep stosb
      NoDoPerByteNullify:
      }

;============================================================
MACRO LIMITVALUE reg1,minvalue,maxvalue {
;===================================================================
      local minok,maxok

      cmp reg1,minvalue
	  jnl minok
	  if (minvalue=0)
	     xor reg1,reg1
	  else
	     mov reg1,minvalue
	  end if
	  jmp maxok
      minok:
      cmp reg1,maxvalue
	  jng maxok
	  if (maxvalue=0)
	     xor reg1,reg1
	  else
	     mov reg1,maxvalue
	  end if
      maxok:
      }

;============================================================
MACRO READFROMFILE fhandle,readoffset,readsize,destbuf,errordestaddr {
;===================================================================
	invoke SetFilePointer,fhandle,readoffset,0,FILE_BEGIN
	cmp eax,-1
	    jz errordestaddr
	sub esp,4
	mov ecx,esp
	invoke ReadFile,fhandle,destbuf,readsize,ecx,0
	pop ecx
	test eax,eax
	     jz errordestaddr
	cmp ecx,readsize
	    jnz errordestaddr
      }

;============================================================
MACRO TESTKEY sourcekey,destjump {
;============================================================
	cmp sourcekey,0
	    jz @f
	cmp eax,sourcekey
	    jz destjump
	@@:
	}
;============================================================
macro FREETPASTRUCT lpstruct {
;============================================================
	mov ecx,lpstruct
	test ecx,ecx
	     jz @f
	push ecx			;for next proc (call [free])
	call [TPAStructUnInitProc]	;destructor (ecx = struct)
	call [free]
	add esp,4
	mov DWORD lpstruct,0
	@@:
      }

;============================================================
macro SHUFXMM register,lowdwordsrc,seconddwordsrc,thirddwordsrc,highdwordsrc {
;============================================================
      shufps register,register,(1*lowdwordsrc+4*seconddwordsrc+16*thirddwordsrc+64*highdwordsrc)
      }
