;========================================================
;main code for FLY cheat
;========================================================
ChangePlayerPosDivertedMethod:

cmp [FLY_MODE_BOOL],0
    jz NoChangePlayerPosDivertedMethod

	mov edx,[esp+4]
	mov eax,[LastXPostion_FLY]
	mov [edx],eax
	mov eax,[LastYPostion_FLY]
	mov [edx+4h],eax
	mov eax,[LastZPostion_FLY]
	mov [edx+8h],eax

NoChangePlayerPosDivertedMethod:
	jmp [TrueChangePlayerPosMethod]
;========================================================
TestForFlyModeKeys:

cmp [IsInGame_BOOL],0
     jz NoFlyModeKeys
cmp [IsInConsole_BOOL],1
     jz NoFlyModeKeys

invoke GetTickCount
       mov edx,eax
       sub eax,[Key_Last_Recorded_Time]
       mov ecx,[UseFlyKeyDelay]
       cmp eax,ecx
	   jb EXITFLYMODEKEYS

;note: Low framerate movement compensation may produce sudden
;bursts if keys are pressed right after a slowdown. This could
;be remedied by saving key state after every frame at end
;of this code and comparing current key states (after slowdown)
;with last known key state (before slowdown). However, this
;would not help if a key is pressed _during_ slowdown, only if
;pressed right before (so no real solution).

       push eax
       mov [Key_Last_Recorded_Time],edx
       fild DWORD [esp]
       fmul [UseFlyKeyDelay_RECIPR]	;elapsedtime*(1/flykeydelay)

       fmul [UseFlySpeed]	;(elapsedtime/flykeydelay)*flyspeed
       fst [FlySpeedTemp]
       fmul [float_two]
       fstp [FlySpeedTemp_Fast]
       add esp,4

       mov edi,[KEY_LIST_ADDR]

       invoke GetAsyncKeyState,[edi+80]
       push MovePlayerForward_Fast
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+88]
       push MovePlayerForward_Slow
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+96]
       push MovePlayerBackward
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+104]
       push MovePlayerSidewaysLeft
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+112]
       push MovePlayerSidewaysRight
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+40]
       push MovePlayerUp
       call Modify_PositionValues

       invoke GetAsyncKeyState,[edi+48]
       push MovePlayerDown
       call Modify_PositionValues

EXITFLYMODEKEYS:
NoFlyModeKeys:
ret
;========================================================
Modify_PositionValues:	;[esp+4]=proc to call, eax=most sign. bit set if go
test eax,80000000h
     jz NoModify_PositionValues

	mov eax,[LocationADDR]
	mov edx,[eax]
	mov edx,[edx+14h]

	push esi
	push edi
	lea esi,[edx+30h]
	mov edi,Temp_Fly_Buffer
	mov ecx,8
	rep movsd
	pop edi
	pop esi

	mov edx,Temp_Fly_Buffer3
	lea ecx,[Temp_Fly_Buffer+0Ch]	;most likely
	push edx
	push Temp_Fly_Buffer2  ;param 1 = dest for values (returned in eax)

	call CONVERT_TO_FACING_PROC_010
	;call DWORD [CONVERT_TO_FACING_PROC]     ;2 params

	mov ecx,eax	       ;Temp_Fly_Buffer2
	call DWORD [esp+4]     ;MODIFY PLAYER POSITION VALUES

NoModify_PositionValues:
ret 4

;=========
;the following code would have been used to update the player's position
;as soon as the position values are changed via GetAsyncKeyState checks. However,
;it does not function 100% properly in this form, and the call is made repeatedly
;by the game itself; it is thus not required at all.

	mov ecx,[LocationADDR]		;(should be done with the player object as well)
	mov eax,[ecx]
	mov edx,[eax+14h]

	push esi
	lea esi,[edx+3Ch]
	mov edi,Temp_Fly_Buffer+12
	mov ecx,5
	rep movsd
	pop esi

	mov ecx,Temp_Fly_Buffer
	mov eax,[LastXPostion_FLY]
	mov [ecx],eax
	mov eax,[LastYPostion_FLY]
	mov [ecx+4],eax
	mov eax,[LastZPostion_FLY]
	mov [ecx+8],eax

	mov eax,[edx]
	push 0
	mov ecx,edx
	push Temp_Fly_Buffer
	call DWORD [eax+38h]	;update position
ret 4

;========================================================
;code and calculations for FLY cheat
;========================================================
MovePlayerForward_Fast:
	;ecx=pointer to 3 facing values x,y,z (VECTOR COMPONENTS)

	fld [FlySpeedTemp_Fast]
	fld DWORD [ecx+8]
	fmul st0,st1
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]

	fld DWORD [ecx] 	;X facing value
	fmulp st1,st0
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

ret
;========================================================
MovePlayerForward_Slow:
	;ecx=pointer to 3 facing values x,y,z

	fld [FlySpeedTemp]
	fld DWORD [ecx+8]
	fmul st0,st1
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]

	fld DWORD [ecx] 	;X facing value
	fmulp st1,st0
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

ret
;========================================================
MovePlayerBackward:
	;ecx=pointer to 3 facing values x,y,z

	fld [FlySpeedTemp]
	fld DWORD [ecx+8]
	fmul st0,st1
	fsubr [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul st0,st1
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]

	fld DWORD [ecx] 	;X facing value
	fmulp st1,st0
	fsubr DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]
ret
;========================================================
MovePlayerSidewaysLeft:      ;calculates sideways-left vector (z component null)
	;ecx=pointer to 3 facing values x,y,z
;(not optimized)
;from vector multiplication with z axis (0,0,1), we gather that
;left mvt vector = (-y facing, +x facing)
;(must be normalized because xyz facing can  have a z component)

	fld DWORD [ecx+4]	  ;Y facing value
	fmul st0,st0		  ;(Y vector)^2
	fld DWORD [ecx] 	  ;X facing value
	fmul st0,st0		  ;(X vector)^2
	faddp st1,st0		  ;(Y vector)^2 + (X vector)^2
	fsqrt			  ;sqrt((Y vector)^2 + (X vector)^2)
				  ;note: this should never to null because view angle is limited in Trespasser

	fld DWORD [ecx+4]	  ;Y facing value
	fdiv st0,st1		  ;Y vector / vector length
	fmul [FlySpeedTemp]
	fsubr [LastXPostion_FLY]
	fstp [LastXPostion_FLY]

	fld DWORD [ecx] 	  ;X facing value
	fdivrp st1,st0		  ;X vector / vector length
	fmul [FlySpeedTemp]
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]

ret

;========================================================
MovePlayerSidewaysRight:      ;calculates sideways-right vector (z component null)
	;ecx=pointer to 3 facing values x,y,z
;from vector multiplication with z axis (0,0,1), we gather that
;right mvt vector = (+y facing, -x facing)
;(must be normalized because xyz facing can  have a z component)

	fld DWORD [ecx+4]	  ;Y facing value
	fmul st0,st0		  ;(Y vector)^2
	fld DWORD [ecx] 	  ;X facing value
	fmul st0,st0		  ;(X vector)^2
	faddp st1,st0		  ;(Y vector)^2 + (X vector)^2
	fsqrt			  ;sqrt((Y vector)^2 + (X vector)^2)
				  ;note: this should never to null because view angle is limited in Trespasser

	fld DWORD [ecx+4]	  ;Y facing value
	fdiv st0,st1		  ;Y vector / vector length
	fmul [FlySpeedTemp]
	fadd [LastXPostion_FLY]
	fstp [LastXPostion_FLY]

	fld DWORD [ecx] 	  ;X facing value
	fdivrp st1,st0		  ;X vector / vector length
	fmul [FlySpeedTemp]
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]

ret

;========================================================
MovePlayerUp:
	fld [LastZPostion_FLY]
	fadd [FlySpeedTemp]
	fstp [LastZPostion_FLY]
ret
;========================================================
MovePlayerDown:
	fld [LastZPostion_FLY]
	fsub [FlySpeedTemp]
	fstp [LastZPostion_FLY]
ret
;========================================================

FLY_Exit_Teleport:
	mov [FLY_Exit_Queued_BOOL],0

	mov edx,FLY_Exit_Queued_BUF
	call CCameraTeleport

ret


